import { AxiosInstance } from 'axios';
import {createAdminAxiosInstance, createUserAxiosInstance} from './util/TokenUtils';

let userAxios: AxiosInstance;
let adminAxios: AxiosInstance;

describe('Users', () => {
  beforeAll(async () => {
    userAxios = await createUserAxiosInstance();
    adminAxios = await createAdminAxiosInstance();
  });

  it('Should a standard user not be allowed to get all authorities', async (done) =>
    await userAxios.get('/api/users/authorities')
      .then(() => done('Should status be 401'))
      .catch((error) => {
        expect(error.message).toContain("Vous n'avez pas les droits");
        done();
      })
  );

  it('Should an admin get all authorities', async () => {
    const { data: authorities } = await adminAxios.get('/api/users/authorities');

    expect(authorities.length).toBe(2);
  });
});
