package com.ippon.borestop.activity.domain;

import com.ippon.borestop.common.domain.error.Assert;
import java.util.Collection;

public class Activity {

  private final Idea idea;
  private final Partners partners;

  public Activity(Idea idea, Partners partners) {
    Assert.notNull("idea", idea);
    Assert.notNull("partners", partners);

    this.idea = idea;
    this.partners = partners;
  }

  public String getLabel() {
    return idea.getLabel();
  }

  public Collection<Partner> getPartners() {
    return partners.getPartners();
  }
}
