package com.ippon.borestop.activity.domain;

import com.ippon.borestop.common.domain.error.Assert;

public class Partner {

  private final String name;
  private final String website;

  private Partner(PartnerBuilder builder) {
    Assert.notBlank("name", builder.name);
    Assert.notBlank("website", builder.website);

    name = builder.name;
    website = builder.website;
  }

  public static PartnerBuilder builder() {
    return new PartnerBuilder();
  }

  public String getName() {
    return name;
  }

  public String getWebsite() {
    return website;
  }

  public static class PartnerBuilder {

    private String name;
    private String website;

    public PartnerBuilder name(String name) {
      this.name = name;

      return this;
    }

    public PartnerBuilder website(String website) {
      this.website = website;

      return this;
    }

    public Partner build() {
      return new Partner(this);
    }
  }
}
