package com.ippon.borestop.activity.domain;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

public class Partners {

  private final Collection<Partner> partners;

  private Partners(PartnersBuilder builder) {
    partners = Collections.unmodifiableCollection(builder.partners);
  }

  public static Partners empty() {
    return builder().build();
  }

  public static PartnersBuilder builder() {
    return new PartnersBuilder();
  }

  public Collection<Partner> getPartners() {
    return partners;
  }

  public static class PartnersBuilder {

    private final List<Partner> partners = new ArrayList<>();

    public PartnersBuilder add(Partner partner) {
      partners.add(partner);

      return this;
    }

    public Partners build() {
      return new Partners(this);
    }
  }
}
