package com.ippon.borestop.activity.infrastructure.primary;

import com.ippon.borestop.activity.application.ActivitesApplicationService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Api(tags = "Activities")
@RequestMapping("/api/activity")
class ActivitesResource {

  private final ActivitesApplicationService activites;

  public ActivitesResource(ActivitesApplicationService activites) {
    this.activites = activites;
  }

  @GetMapping
  @ApiOperation("Get an activity")
  public ResponseEntity<RestActivity> getActivity() {
    return ResponseEntity.ok(RestActivity.from(activites.next()));
  }
}
