package com.ippon.borestop.activity.infrastructure.primary;

import com.ippon.borestop.activity.domain.Activity;
import io.swagger.annotations.ApiModel;
import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

@ApiModel(value = "Activity", description = "An ideal activity for you!")
class RestActivity {

  private final String label;
  private final Collection<RestPartner> partners;

  private RestActivity(String label, Collection<RestPartner> partners) {
    this.label = label;
    this.partners = partners;
  }

  public static RestActivity from(Activity activity) {
    if (activity == null) {
      return null;
    }

    List<RestPartner> partners = activity.getPartners().stream().map(RestPartner::from).collect(Collectors.toList());
    return new RestActivity(activity.getLabel(), partners);
  }

  public String getLabel() {
    return label;
  }

  public Collection<RestPartner> getPartners() {
    return partners;
  }
}
