package com.ippon.borestop.activity.infrastructure.primary;

import com.ippon.borestop.activity.domain.Partner;
import io.swagger.annotations.ApiModel;

@ApiModel(value = "Partner", description = "Partner for an idea")
class RestPartner {

  private final String name;
  private final String website;

  private RestPartner(String name, String website) {
    this.name = name;
    this.website = website;
  }

  static RestPartner from(Partner partner) {
    return new RestPartner(partner.getName(), partner.getWebsite());
  }

  public String getName() {
    return name;
  }

  public String getWebsite() {
    return website;
  }
}
