package com.ippon.borestop.activity.infrastructure.secondary;

import com.ippon.borestop.activity.domain.Category;
import java.util.Arrays;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;
import org.apache.commons.lang3.StringUtils;

enum BoredApiCategory {
  COOKING("cooking"),
  RELAXATION("relaxation"),
  DEFAULT("default");

  private static final Map<String, BoredApiCategory> categories = buildCategories();

  private static Map<String, BoredApiCategory> buildCategories() {
    return Arrays.stream(values()).collect(Collectors.toMap(BoredApiCategory::getLabel, Function.identity()));
  }

  private final String label;

  BoredApiCategory(String label) {
    this.label = label;
  }

  private String getLabel() {
    return label;
  }

  static BoredApiCategory from(String type) {
    return categories.getOrDefault(StringUtils.lowerCase(type), DEFAULT);
  }

  Category toDomain() {
    return Category.valueOf(name());
  }
}
