package com.ippon.borestop.activity.infrastructure.secondary;

import com.ippon.borestop.activity.domain.Category;
import com.ippon.borestop.activity.domain.Idea;
import com.ippon.borestop.activity.domain.IdeasRepository;
import org.springframework.boot.web.client.RestTemplateBuilder;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestClientException;
import org.springframework.web.client.RestTemplate;

@Service
class BoredApiIdeasRepository implements IdeasRepository {

  private final RestTemplate rest;
  private final String url;

  BoredApiIdeasRepository(RestTemplateBuilder restBuilder, BoredApiProperties properties) {
    this.rest = restBuilder.setConnectTimeout(properties.getConnectTimeout()).setReadTimeout(properties.getReadTimeout()).build();

    url = properties.getUrl();
  }

  @Override
  public Idea next() {
    try {
      BoredApiResponse apiResponse = rest.getForEntity(url, BoredApiResponse.class).getBody();

      return apiResponse.toDomain();
    } catch (RestClientException e) {
      return new Idea("Go grab a beer", Category.RELAXATION);
    }
  }
}
