package com.ippon.borestop.common.domain.error;

public class MissingMandatoryValueException extends BorestopException {

  protected MissingMandatoryValueException(BorestopExceptionBuilder builder) {
    super(builder);
  }

  private static BorestopExceptionBuilder builder(BorestopMessage borestopMessage, String fieldName, String message) {
    return BorestopException
      .builder(borestopMessage)
      .status(ErrorStatus.INTERNAL_SERVER_ERROR)
      .argument("field", fieldName)
      .message(message);
  }

  private static String defaultMessage(String fieldName) {
    return "The field \"" + fieldName + "\" is mandatory and wasn't set";
  }

  public static MissingMandatoryValueException forNullValue(String fieldName) {
    return new MissingMandatoryValueException(
      builder(StandardMessage.SERVER_MANDATORY_NULL, fieldName, defaultMessage(fieldName) + " (null)")
    );
  }

  public static MissingMandatoryValueException forBlankValue(String fieldName) {
    return new MissingMandatoryValueException(
      builder(StandardMessage.SERVER_MANDATORY_BLANK, fieldName, defaultMessage(fieldName) + " (blank)")
    );
  }
}
