package com.ippon.borestop.activity.domain;

import static com.ippon.borestop.activity.domain.ActivitiesFixture.*;
import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.*;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.springframework.test.context.junit.jupiter.SpringExtension;

@ExtendWith(SpringExtension.class)
class ActivitiesUnitTest {

  @Mock
  private IdeasRepository ideas;

  @Mock
  private PartnersRepository partners;

  @InjectMocks
  private Activities activities;

  @Test
  void shouldBuildActivity() {
    when(ideas.next()).thenReturn(idea());
    when(partners.find(Category.RELAXATION)).thenReturn(threePartners());

    Activity activity = activities.next();

    assertThat(activity.getLabel()).isEqualTo(label());
    assertThat(activity.getPartners())
      .usingFieldByFieldElementComparator()
      .containsExactly(firstPartner(), secondPartner(), thirdPartner());
  }
}
