package com.ippon.borestop.activity.domain;

import static org.assertj.core.api.Assertions.assertThatThrownBy;

import com.ippon.borestop.common.domain.error.MissingMandatoryValueException;
import org.junit.jupiter.api.Test;

class IdeaUnitTest {

  @Test
  void shouldNotBuildWithoutLabel() {
    assertThatThrownBy(() -> new Idea(null, Category.RELAXATION))
      .isExactlyInstanceOf(MissingMandatoryValueException.class)
      .hasMessageContaining("label");
  }

  @Test
  void shouldNotBuildWithBlankLabel() {
    assertThatThrownBy(() -> new Idea(" ", Category.RELAXATION))
      .isExactlyInstanceOf(MissingMandatoryValueException.class)
      .hasMessageContaining("label");
  }

  @Test
  void shouldNotBuildWithoutCategory() {
    assertThatThrownBy(() -> new Idea("label", null))
      .isExactlyInstanceOf(MissingMandatoryValueException.class)
      .hasMessageContaining("category");
  }
}
