package com.ippon.borestop.activity.domain;

import static org.assertj.core.api.Assertions.*;

import com.ippon.borestop.activity.domain.Partner.PartnerBuilder;
import com.ippon.borestop.common.domain.error.MissingMandatoryValueException;
import org.junit.jupiter.api.Test;

class PartnerUnitTest {

  @Test
  void shouldNotBuildWithoutName() {
    assertThatThrownBy(() -> fullBuilder().name(null).build())
      .isExactlyInstanceOf(MissingMandatoryValueException.class)
      .hasMessageContaining("name");
  }

  @Test
  void shouldNotBuildWithBlankName() {
    assertThatThrownBy(() -> fullBuilder().name(" ").build())
      .isExactlyInstanceOf(MissingMandatoryValueException.class)
      .hasMessageContaining("name");
  }

  @Test
  void shouldNotBuildWithoutWebsite() {
    assertThatThrownBy(() -> fullBuilder().website(null).build())
      .isExactlyInstanceOf(MissingMandatoryValueException.class)
      .hasMessageContaining("website");
  }

  @Test
  void shouldNotBuildWithBlankWebsite() {
    assertThatThrownBy(() -> fullBuilder().website(" ").build())
      .isExactlyInstanceOf(MissingMandatoryValueException.class)
      .hasMessageContaining("website");
  }

  private PartnerBuilder fullBuilder() {
    return Partner.builder().name("name").website("http://name");
  }
}
