package com.ippon.borestop.activity.infrastructure.primary;

import static org.assertj.core.api.Assertions.*;

import com.ippon.borestop.common.infrastructure.primary.CucumberTestContext;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.web.client.TestRestTemplate;

public class ActivitiesStep {

  @Autowired
  private TestRestTemplate rest;

  @When("I get an activity")
  public void getActivity() {
    rest.getForEntity("/api/activity", Void.class);
  }

  @Then("My activity should be {string}")
  public void shouldGetActivity(String activity) {
    assertThat(CucumberTestContext.getElement("$.label")).isEqualTo(activity);
  }

  @Then("My partners should be")
  public void shouldGetPartners(List<Map<String, String>> partners) {
    for (int line = 0; line < partners.size(); line++) {
      String partnerPath = "$.partners[" + line + "]";

      assertThat(CucumberTestContext.getElement(partnerPath + ".name")).isEqualTo(partners.get(line).get("Name"));
      assertThat(CucumberTestContext.getElement(partnerPath + ".website")).isEqualTo(partners.get(line).get("Website"));
    }
  }
}
