package com.ippon.borestop.activity.infrastructure.primary;

import static com.ippon.borestop.activity.domain.ActivitiesFixture.*;
import static org.assertj.core.api.Assertions.*;

import com.ippon.borestop.common.infrastructure.primary.TestJson;
import org.junit.jupiter.api.Test;

class RestActivityUnitTest {

  @Test
  void shouldConvertToNullFromNullDomain() {
    assertThat(RestActivity.from(null)).isNull();
  }

  @Test
  void shouldSerializeToJson() {
    assertThat(defaultActivity()).isEqualTo(json());
  }

  private String defaultActivity() {
    return TestJson.writeAsString(RestActivity.from(activity()));
  }

  private String json() {
    return "{\"label\":\"This is my idea\",\"partners\":[{\"name\":\"name\",\"website\":\"http://name.com\"},{\"name\":\"second\",\"website\":\"http://second.com\"},{\"name\":\"third\",\"website\":\"http://third.com\"}]}";
  }
}
