package com.ippon.borestop.activity.infrastructure.secondary;

import static org.assertj.core.api.Assertions.*;

import com.ippon.borestop.activity.domain.Category;
import java.util.Arrays;
import java.util.Set;
import java.util.stream.Collectors;
import org.junit.jupiter.api.Test;

class BoredApiCategoryUnitTest {

  @Test
  void shouldHaveValueForAllDomainCategories() {
    Set<Category> mappedCategories = Arrays.stream(BoredApiCategory.values()).map(BoredApiCategory::toDomain).collect(Collectors.toSet());

    assertThat(mappedCategories).containsExactlyInAnyOrder(Category.values());
  }

  @Test
  void shouldConvertFromType() {
    assertThat(BoredApiCategory.from("Cooking")).isEqualTo(BoredApiCategory.COOKING);
  }

  @Test
  void shouldConvertFromUnknownType() {
    assertThat(BoredApiCategory.from("unknown")).isEqualTo(BoredApiCategory.DEFAULT);
  }
}
