package com.ippon.borestop.activity.infrastructure.secondary;

import static org.assertj.core.api.Assertions.*;

import com.ippon.borestop.activity.domain.Category;
import com.ippon.borestop.activity.domain.Idea;
import com.ippon.borestop.common.infrastructure.primary.TestJson;
import org.junit.jupiter.api.Test;

class BoredApiResponseUnitTest {

  @Test
  void shouldDeserializeFromJson() {
    BoredApiResponse response = TestJson.readFromJson(json(), BoredApiResponse.class);

    assertThat(response.getActivity()).isEqualTo("Cook something together with someone");
    assertThat(response.getType()).isEqualTo("cooking");
  }

  @Test
  void shouldConvertToDomain() {
    BoredApiResponse response = new BoredApiResponse("activity", "cooking");

    Idea idea = response.toDomain();

    assertThat(idea.getLabel()).isEqualTo("activity");
    assertThat(idea.getCategory()).isEqualTo(Category.COOKING);
  }

  private String json() {
    return (
      "{\n" +
      "  \"activity\": \"Cook something together with someone\",\n" +
      "  \"type\": \"cooking\",\n" +
      "  \"participants\": 2,\n" +
      "  \"price\": 0.3,\n" +
      "  \"link\": \"\",\n" +
      "  \"key\": \"1799120\",\n" +
      "  \"accessibility\": 0.8\n" +
      "}"
    );
  }
}
