package com.ippon.borestop.common.infrastructure.primary;

import static org.assertj.core.api.Assertions.assertThat;

import java.util.List;
import org.junit.jupiter.api.Test;

class BorestopErrorUnitTest {

  @Test
  public void shouldGetErrorInformation() {
    BorestopFieldError fieldError = BorestopFieldErrorUnitTest.defaultFieldError();
    BorestopError error = defaultError(fieldError);

    assertThat(error.getErrorType()).isEqualTo("type");
    assertThat(error.getMessage()).isEqualTo("message");
    assertThat(error.getFieldsErrors()).containsExactly(fieldError);
  }

  @Test
  public void shouldSerializeToJson() {
    assertThat(TestJson.writeAsString(defaultError(BorestopFieldErrorUnitTest.defaultFieldError()))).isEqualTo(defaultJson());
  }

  @Test
  void shouldDeserializeFromJson() {
    assertThat(TestJson.readFromJson(defaultJson(), BorestopError.class))
      .usingRecursiveComparison()
      .isEqualTo(defaultError(BorestopFieldErrorUnitTest.defaultFieldError()));
  }

  private String defaultJson() {
    return "{\"errorType\":\"type\",\"message\":\"message\",\"fieldsErrors\":[" + BorestopFieldErrorUnitTest.defaultJson() + "]}";
  }

  private BorestopError defaultError(BorestopFieldError fieldError) {
    return new BorestopError("type", "message", List.of(fieldError));
  }
}
