package com.ippon.borestop.common.infrastructure.primary;

import static org.assertj.core.api.Assertions.assertThat;

import org.junit.jupiter.api.Test;

class BorestopFieldErrorUnitTest {

  @Test
  public void shouldGetFieldErrorInformation() {
    BorestopFieldError fieldError = defaultFieldError();

    assertThat(fieldError.getFieldPath()).isEqualTo("path");
    assertThat(fieldError.getReason()).isEqualTo("reason");
    assertThat(fieldError.getMessage()).isEqualTo("message");
  }

  @Test
  public void shouldSerializeToJson() {
    assertThat(TestJson.writeAsString(defaultFieldError())).isEqualTo(defaultJson());
  }

  static BorestopFieldError defaultFieldError() {
    return BorestopFieldError.builder().fieldPath("path").reason("reason").message("message").build();
  }

  static String defaultJson() {
    return "{\"fieldPath\":\"path\",\"reason\":\"reason\",\"message\":\"message\"}";
  }
}
