package fr.ippon.employee;

import java.util.Collection;
import java.util.Comparator;
import java.util.List;

public class Employees {

  private final List<Employee> employees;

  public Employees(Employee... employees) {
    this.employees = List.of(employees);
  }

  public Collection<Employee> get() {
    return employees;
  }

  public Collection<String> sundayWorkers() {
    return employees.stream()
        .filter(Employee::isAdult)
        .map(Employee::name)
        .sorted(Comparator.reverseOrder())
        .toList();
  }

}
