package fr.ippon.employee;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

class EmployeeReportTest {

  @Test
  void shouldGetEmployees() {
    Employees employees = new Employees(mike());

    assertThat(employees.get()).containsExactly(mike());
  }

  @Test
  void shouldGetUnmodifiableEmployees() {
    assertThatThrownBy(() -> new Employees().get()
        .clear()).isExactlyInstanceOf(
            UnsupportedOperationException.class);
  }

  @Test
  void shouldGetSundayWorkers() {
    Employees employees = new Employees(
        new Employee("Max", 17), mike(),
        new Employee("jean charles", 18));

    assertThat(employees.sundayWorkers())
        .containsExactly("Mike", "Jean Charles");
  }

  private Employee mike() {
    return new Employee("MIKE", 51);
  }

}
