package fr.ippon.exception;

import static org.assertj.core.api.Assertions.*;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.NoSuchFileException;
import java.nio.file.Paths;
import org.junit.jupiter.api.Test;

class ExceptionTest {

  @Test
  void shouldNotBuildFirstnameWithoutFirstname() {
    assertThatThrownBy(() -> new Firstname(null))
      .isExactlyInstanceOf(MissingMandatoryValueException.class)
      .hasMessageContaining("firstname");
  }

  @Test
  void shouldNotUpdateNullString() {
    String pouet = null;

    assertThatThrownBy(() -> pouet.substring(2)).isExactlyInstanceOf(NullPointerException.class);
  }

  @Test
  void shouldNotReadUnknownFile() throws IOException {
    assertThatThrownBy(() -> Files.readAllBytes(Paths.get("target/unknown"))).isExactlyInstanceOf(NoSuchFileException.class);
  }
}
