package fr.ippon.factory;

import java.util.Optional;

public class Firstname {

  private final String firstname;

  public Firstname(String firstname) {
    assertFirstname(firstname);

    this.firstname = firstname;
  }

  private void assertFirstname(String firstname) {
    if (firstname == null) {
      throw new IllegalArgumentException();
    }
  }

  public static Optional<Firstname> of(String firstname) {
    if (firstname == null) {
      return Optional.empty();
    }

    return Optional.of(new Firstname(firstname));
  }

  public String get() {
    return firstname;
  }
}
