package fr.ippon.factory;

public class Person {

  private final Firstname firstname;
  private final Lastname lastname;

  private Person(PersonBuilder builder) {
    firstname = new Firstname(builder.firstname);
    lastname = new Lastname(builder.lastname);
  }

  public static PersonBuilder builder() {
    return new PersonBuilder();
  }

  public Firstname getFirstname() {
    return firstname;
  }

  public Lastname getLastname() {
    return lastname;
  }

  public static class PersonBuilder {

    private String firstname;
    private String lastname;

    public PersonBuilder firstname(String firstname) {
      this.firstname = firstname;

      return this;
    }

    public PersonBuilder lastname(String lastname) {
      this.lastname = lastname;

      return this;
    }

    public Person build() {
      return new Person(this);
    }
  }
}
