package fr.ippon.factory;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

public class FirstnameTest {

  @Test
  void shouldNotBuildWithoutFirstname() {
    assertThatThrownBy(() -> new Firstname(null)).isExactlyInstanceOf(IllegalArgumentException.class);
  }

  @Test
  void shouldGetFirstname() {
    assertThat(new Firstname("Jean").get()).isEqualTo("Jean");
  }

  @Test
  void shouldGetEmptyFirstnameWithoutFirstname() {
    assertThat(Firstname.of(null)).isEmpty();
  }

  @Test
  void shouldGetFirstnameFromActualFirstname() {
    assertThat(Firstname.of("Jean").get().get()).isEqualTo("Jean");
  }
}
