package fr.ippon.kata.h2g2;

import static fr.ippon.kata.h2g2.Book.*;
import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

class H2G2Test {

  @Test
  void shouldBeFreeWithoutBooks() {
    assertThat(Shop.buy()).isEqualTo(0);
  }

  @Test
  void shouldPayFullPriceForOneBook() {
    assertThat(Shop.buy(FIRST)).isEqualTo(8);
  }

  @Test
  void shouldPayFullPriceForTwoFirstBooks() {
    assertThat(Shop.buy(FIRST, FIRST)).isEqualTo(8 * 2);
  }

  @Test
  void shouldGetFivePercentOffWithTwoBooksFromSeries() {
    assertThat(Shop.buy(FIRST, SECOND)).isEqualTo(8 * 2 * 0.95f);
  }

  @Test
  void shouldGetTenPercentOffWithThreeBooksFromSeries() {
    assertThat(Shop.buy(THIRD, FORTH, FIFTH)).isEqualTo(8 * 3 * 0.90f);
  }

  @Test
  void shouldGetTwentyPercentOffWithFourBooksFromSeries() {
    assertThat(Shop.buy(SECOND, THIRD, FORTH, FIFTH)).isEqualTo(8 * 4 * 0.80f);
  }

  @Test
  void shouldGetTwentyFivePercentOffWithFiveBooksFromSeries() {
    assertThat(Shop.buy(FIRST, SECOND, THIRD, FORTH, FIFTH)).isEqualTo(8 * 5 * 0.75f);
  }

  @Test
  void shouldGetBestPossibleReductionForFirstFirstSecond() {
    assertThat(Shop.buy(FIRST, FIRST, SECOND)).isEqualTo(8 + (8 * 2 * 0.95f));
  }

  @Test
  void shouldGetBestPossibleReductionForBasketOfHell() {
    assertThat(Shop.buy(FIRST, FIRST, SECOND, SECOND, THIRD, THIRD, FORTH, FIFTH)).isEqualTo(2 * 8 * 4 * 0.8f);
  }
}
