package fr.ippon.monad;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

class MaybeTest {

  @Test
  void shouldMapFromIntegerToString() {
    assertThat(Maybe.pure(42).map(String::valueOf)).usingRecursiveComparison().isEqualTo(Maybe.pure("42"));
  }

  @Test
  void shouldNotMapFailedMaybe() {
    assertThat(Maybe.fail().map(String::valueOf)).usingRecursiveComparison().isEqualTo(Maybe.fail());
  }

  @Test
  void shouldBindPureToPure() {
    assertThat(Maybe.pure(42).bind(value -> Maybe.pure(String.valueOf(value)))).usingRecursiveComparison().isEqualTo(Maybe.pure("42"));
  }
}
