package fr.ippon.monad;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

class StateTest {

  @Test
  void shouldWriteSyracuseSequence() {
    State<Integer, Integer> syracuse = intState()
      .bind(
        previous -> {
          Integer next = previous % 2 == 0 ? previous / 2 : previous * 3 + 1;

          return State.set(next).bind(dummy -> State.pure(next));
        }
      );

    assertThat(syracuse.run(5)).isEqualTo(new State.Result<>(16, 16));
  }

  private State<Integer, Integer> intState() {
    return State.get();
  }
}
