package fr.ippon.kata.pagination;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

public class PaginationTest {

  @Test
  void shouldGetPageTwoOfFive() {
    assertThat(Pagination.current(2).total(5).display()).isEqualTo("1 (2) 3 4 5");
  }

  @Test
  void shouldDisplayFourtyTwoOfHundred() {
    assertThat(Pagination.current(42).total(100).display()).isEqualTo("1 … 41 (42) 43 … 100");
  }

  @Test
  void shouldDisplayPageTwoOfNine() {
    assertThat(Pagination.current(2).total(9).display()).isEqualTo("1 (2) 3 4 5 … 9");
  }

  @Test
  void shouldDisplayPageOneOfSeven() {
    assertThat(Pagination.current(1).total(7).display()).isEqualTo("(1) 2 3 4 5 6 7");
  }

  @Test
  void shouldDisplayPageEightOfNine() {
    assertThat(Pagination.current(8).total(9).display()).isEqualTo("1 … 5 6 7 (8) 9");
  }

  @Test
  void shouldDisplayPageFiveOfNine() {
    assertThat(Pagination.current(5).total(9).display()).isEqualTo("1 … 4 (5) 6 … 9");
  }
}
