package fr.ippon;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

public class PlayingWithFinally {

  @Test
  public void playingWithReturn() {
    // assertThat(finallyReturn()).isEqualTo(42);
    assertThat(finallyReturn()).isEqualTo(1337);
  }

  @SuppressWarnings("finally")
  private int finallyReturn() {
    try {
      return 42;
    } finally {
      return 1337;
    }
  }

  @Test
  public void playingWithThrow() {
    // assertThat(finallyThrow()).isEqualTo(42);
    assertThatThrownBy(() -> finallyThrow()).isInstanceOf(IllegalArgumentException.class).hasMessageContaining("Damned");
  }

  @SuppressWarnings("finally")
  private int finallyThrow() {
    try {
      return 42;
    } finally {
      throw new IllegalArgumentException("Damned");
    }
  }
}
