package fr.ippon;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

public class PlayingWithInstanciations {

  private static final long instanciation = System.currentTimeMillis();

  @Test
  public void playingWithInstanciationTime() throws InterruptedException {
    Thread.sleep(10);
    long start = System.currentTimeMillis();

    // assertThat(start).isLessThanOrEqualTo(instanciation);
    assertThat(start).isGreaterThan(instanciation);
    MyPrivateClass.doStuff();
    assertThat(start).isLessThanOrEqualTo(MyPrivateClass.instanciation);
    // assertThat(start).isGreaterThan(MyPrivateClass.instanciation);
  }

  private static class MyPrivateClass {

    private static final long instanciation = System.currentTimeMillis();

    private static void doStuff() {}
  }
}
