package fr.ippon.streams;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

public class MallUnitTest {

  private static final Mall mall = mall(shop("Nature", employee("Michel", 25)), shop("Beer", employee("Bob", 42), employee("John", 19)));

  @Test
  void shouldGetShopNames() {
    assertThat(mall.getShopNames()).containsExactly("Beer", "Nature");
  }

  @Test
  void shouldGetZeroAverageAgeWithoutShopInMall() {
    assertThat(new Mall().getEmployeesMeanAge()).isEqualTo("0");
  }

  @Test
  void shouldGetEmployeesAverageAge() {
    assertThat(mall.getEmployeesMeanAge()).isEqualTo("28.67");
  }

  @Test
  void shouldGetEmployeesOverAge() {
    assertThat(mall.getEmployeesOver(20)).containsExactly("Bob", "Michel");
  }

  private static Mall mall(Shop... shops) {
    return new Mall(shops);
  }

  private static Shop shop(String name, Employee... employees) {
    return new Shop(name, employees);
  }

  private static Employee employee(String name, int age) {
    return new Employee(name, age);
  }
}
