package fr.ippon.markov;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class MarkovChain {

  private final Map<String, WordStats> stats = new ConcurrentHashMap<>();

  public void learn(String text) {
    String[] words = text.split(" ");
    for (int i = 0; i < words.length - 1; i++) {
      String current = words[i];
      String next = words[i + 1];

      append(current, next);
    }
  }

  private void append(String current, String next) {
    stats
        .computeIfAbsent(current.toLowerCase(),
            this::newWordStats)
        .add(next);
  }

  private WordStats newWordStats(String dummy) {
    return new WordStats();
  }

  public WordStats stats(String word) {
    return stats.getOrDefault(word.toLowerCase(),
        new WordStats());
  }

  public Map<String, WordStats> stats() {
    return stats;
  }
}
