package fr.ippon.markov;

import java.util.Collection;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.atomic.AtomicInteger;

public class WordStats {

  private final AtomicInteger size = new AtomicInteger();
  private final Map<String, AtomicInteger> stats = new ConcurrentHashMap<>();

  public void add(String word) {
    size.incrementAndGet();
    stats.computeIfAbsent(word, key -> new AtomicInteger())
        .incrementAndGet();
  }

  public Collection<Stat> get() {
    return stats.entrySet()
        .stream()
        .map(entry -> new Stat(entry.getKey(),
            entry.getValue()
                .floatValue() / size.floatValue()))
        .toList();
  }

}
