package fr.ippon.rental;

public class ConsoleRenderer implements Renderer {

  @Override
  public String header(String name) {
    return "Rental Record for " + name + "\n";
  }

  @Override
  public String movie(Rental rental, double amount) {
    return "\t" + rental.getMovie().getTitle() + "\t" + String.valueOf(amount) + "\n";
  }

  @Override
  public String footer(double totalAmount, int frequentRenterPoints) {
    return new StringBuilder()
      .append("Amount owed is ")
      .append(totalAmount)
      .append("\n")
      .append("You earned ")
      .append(frequentRenterPoints)
      .append(" frequent renter points")
      .toString();
  }
}
