package fr.ippon.rental;

public class HtmlRenderer implements Renderer {

  @Override
  public String header(String name) {
    return "<h1>Rental Record for " + name + "</h1>\n<table>";
  }

  @Override
  public String movie(Rental rental, double amount) {
    return "<tr><td>" + rental.getMovie().getTitle() + "</td><td>" + String.valueOf(amount) + "</td></tr>\n";
  }

  @Override
  public String footer(double totalAmount, int frequentRenterPoints) {
    return new StringBuilder()
      .append("</table><p>Amount owed is <em>")
      .append(totalAmount)
      .append("</em></p>\n")
      .append("<p>You earned <em>")
      .append(frequentRenterPoints)
      .append("</em> frequent renter points</p>")
      .toString();
  }
}
