import java.util.Map;
import java.util.function.BinaryOperator;

public class ArgumentReplacer {

  public static final String BEGINING_MUSTACH = "\\{\\{\\s*";
  public static final String ENDING_MUSTACH = "\\s*\\}\\}";

  public static String replace(String template, Map<String, String> arguments) {
    if (needNoReplace(template, arguments)) {
      return template;
    }

    return arguments.entrySet().stream().reduce(template, ArgumentReplacer::replaceEntry, nothing());
  }

  private static boolean needNoReplace(String template, Map<String, String> arguments) {
    return template == null || arguments == null;
  }

  private static String replaceEntry(String result, Map.Entry<String, String> entry) {
    return result.replaceAll(BEGINING_MUSTACH + entry.getKey() + ENDING_MUSTACH, entry.getValue());
  }

  private static BinaryOperator<String> nothing() {
    return (k, v) -> v;
  }
}
