import static org.assertj.core.api.Assertions.assertThat;

import java.util.Map;
import org.assertj.core.api.Assertions;
import org.junit.jupiter.api.Test;

class SampleTest {

  @Test
  void shouldGetInputStringWithoutArgumentToReplace() {
    assertThat(ArgumentReplacer.replace("Bonjour Homer", null)).isEqualTo("Bonjour Homer");
  }

  @Test
  void shouldGetInputStringWithArgumentReplaced() {
    assertThat(ArgumentReplacer.replace("Bonjour {{firstname}}", Map.of("firstname", "Homer"))).isEqualTo("Bonjour Homer");
  }

  @Test
  void shouldGetNullResultWithoutTemplate() {
    assertThat(ArgumentReplacer.replace(null, Map.of("firstname", "Homer"))).isNull();
  }

  @Test
  void shouldGetInputStringReplacedWithSpace() {
    assertThat(ArgumentReplacer.replace("Bonjour {{firstname}} {{ lastname  }}", Map.of("firstname", "Homer", "lastname", "Simpson")))
      .isEqualTo("Bonjour Homer Simpson");
  }
}
