package fr.craft.kata.domain;

import java.util.Comparator;

public record Name(Firstname firstname, Lastname lastname)
    implements Comparable<Name> {

  private static final Comparator<Name> COMPARATOR = Comparator
      .comparing(Name::firstname)
      .thenComparing(Name::lastname);

  public Name(String firstname, String lastname) {
    this(new Firstname(firstname), new Lastname(lastname));
  }

  public String get() {
    return firstname.get() + " " + lastname.get();
  }

  @Override
  public int compareTo(Name other) {
    return COMPARATOR.compare(this, other);
  }

}
