package fr.craft.kata.domain;

import java.util.List;

public record Names(List<Name> names) {

  public Names(Name... names) {
    this(buildNames(names));
  }

  private static List<Name> buildNames(Name... names) {
    if (names == null || names.length == 0) {
      throw new IllegalArgumentException(
          "Can't build without names");
    }

    return List.of(names)
        .stream()
        .sorted()
        .toList();
  }

  public List<Name> get() {
    return names();
  }

}
