package fr.craft.kata.domain;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

class FirstnameUnitTest {

  @Test
  void shouldNotBuildWihtoutFirstname() {
    assertThatThrownBy(() -> new Firstname(null))
        .isExactlyInstanceOf(IllegalArgumentException.class)
        .hasMessageContaining("firstname");
  }

  @Test
  void shouldNotBuildWihtBlankFirstname() {
    assertThatThrownBy(() -> new Firstname(" "))
        .isExactlyInstanceOf(IllegalArgumentException.class)
        .hasMessageContaining("firstname");
  }

  @Test
  void shouldCapitalizeSimpleFirstname() {
    assertThat(new Firstname("jean").get())
    .isEqualTo("Jean");
  }

  @Test
  void shouldCapitalizeComposeFirstname() {
    assertThat(new Firstname("jean PAUL-jacque").get())
        .isEqualTo("Jean Paul-Jacque");
  }

}
