package fr.craft.kata.domain;

import static fr.craft.kata.domain.NamesFixture.*;
import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

class NamesUnitTest {

  @Test
  void shouldNotBuildWithNullName() {
    assertThatThrownBy(() -> new Names((Name[]) null))
        .isExactlyInstanceOf(IllegalArgumentException.class)
        .hasMessageContaining("names");
  }

  @Test
  void shouldNotBuildWithoutName() {
    assertThatThrownBy(() -> new Names())
        .isExactlyInstanceOf(IllegalArgumentException.class)
        .hasMessageContaining("names");
  }

  @Test
  void shouldGetSortedNames() {
    assertThat(new Names(jeanPaul(), colin()).get())
        .containsExactly(colin(), jeanPaul());
  }

}
