package fr.ippon.kata.puissance4;

import static fr.ippon.kata.puissance4.Joueur.*;

import java.util.Scanner;

public class Puissance4 {

  private static final Integer N = 20;

  private Character grille[][];

  private Puissance4() {
    grille = new Character[N][N];

    for (int i = 0; i <= 12; i++) {
      for (int j = 0; j <= 13; j++) {
        grille[i][j] = '$';
      }
    }

    for (int i = 3; i <= 9; i++) {
      for (int j = 3; j <= 10; j++) {
        grille[i][j] = '*';
      }
    }
  }

  public static int menu() {
    int choix;
    Scanner sc = new Scanner(System.in);
    System.out.println("\n\t\t\t***************************\n\t\t\t***\tPuissance 4\t***\n\t\t\t***************************");
    System.out.println("\n\n[1] Un joueur\n");
    System.out.println("[2] Deux joueurs\n");
    System.out.println("[3] Regle du jeu");

    do {
      choix = sc.nextInt();
    } while (choix < 1 || choix > 3);
    return choix;
  }

  public void afficherGrille() {
    afficherEntete();

    for (int ligne = 3; ligne <= 9; ligne++) {
      for (int colonne = 3; colonne <= 10; colonne++) {
        System.out.print("| ");
        System.out.print(grille[ligne][colonne]);
      }

      System.out.println("|");
    }

    System.out.println(" ------------------------");
  }

  private void afficherEntete() {
    System.out.println("\n ");

    for (int k = 1; k <= 8; k++) {
      System.out.print("[" + k + "]");
    }

    System.out.println("\n");
  }

  public boolean jouer(Joueur joueur) {
    int colonne = colonneJouee();
    int ligne = getLigne(colonne);

    grille[ligne][colonne] = joueur.getPion();
    afficherGrille();

    return estGagne(ligne, colonne);
  }

  private static int colonneJouee() {
    int choix;
    Scanner sc = new Scanner(System.in);
    do {
      choix = sc.nextInt();
      if (choix > 8 || choix < 1) {
        System.out.println("Choix incorrect, entrez un nombre entre 1 et 8");
      }
    } while (choix > 8 || choix < 1);

    return choix + 2;
  }

  private int getLigne(int colonne) {
    int ligne = 9;

    while (ligneJouee(colonne, ligne)) {
      ligne = ligne - 1;
    }

    return ligne;
  }

  private boolean ligneJouee(int colonne, int ligne) {
    return grille[ligne][colonne] == JOUEUR_1.getPion() || grille[ligne][colonne] == JOUEUR_2.getPion();
  }

  public boolean jouerIA() {
    int i = 0, j = 0, x = 0, y = 0, choix = 0;

    if (choix == 0) {
      for (i = 3; i <= 9; i++) {
        for (j = 3; j <= 10; j++) {
          if (choix == 0) {
            if (grille[i][j] == '*' && (grille[i + 1][j] == 'X' || grille[i + 1][j] == 'O' || grille[i + 1][j] == '$')) {
              if (
                (grille[i + 1][j] == 'O' && grille[i + 1][j] == grille[i + 2][j] && grille[i + 2][j] == grille[i + 3][j]) ||
                (
                  grille[i + 1][j - 1] == 'O' &&
                  grille[i + 1][j - 1] == grille[i + 2][j - 2] &&
                  grille[i + 2][j - 2] == grille[i + 3][j - 3]
                ) ||
                (grille[i][j - 1] == 'O' && grille[i][j - 1] == grille[i][j - 2] && grille[i][j - 2] == grille[i][j - 3]) ||
                (
                  grille[i - 1][j - 1] == 'O' &&
                  grille[i - 1][j - 1] == grille[i - 2][j - 2] &&
                  grille[i - 2][j - 2] == grille[i - 3][j - 3]
                ) ||
                (
                  grille[i - 1][j + 1] == 'O' &&
                  grille[i - 1][j + 1] == grille[i - 2][j + 2] &&
                  grille[i - 2][j + 2] == grille[i - 3][j + 3]
                ) ||
                (grille[i][j + 1] == 'O' && grille[i][j + 1] == grille[i][j + 2] && grille[i][j + 2] == grille[i][j + 3]) ||
                (
                  grille[i + 1][j + 1] == 'O' &&
                  grille[i + 1][j + 1] == grille[i + 2][j + 2] &&
                  grille[i + 2][j + 2] == grille[i + 3][j + 3]
                ) ||
                /* new */(
                  grille[i + 1][j + 1] == 'O' &&
                  grille[i - 1][j - 1] == grille[i + 1][j + 1] &&
                  grille[i - 1][j - 1] == grille[i - 2][j - 2]
                ) ||
                (
                  grille[i - 1][j - 1] == 'O' &&
                  grille[i + 1][j + 1] == grille[i - 1][j - 1] &&
                  grille[i + 1][j + 1] == grille[i + 2][j + 2]
                ) ||
                (
                  grille[i - 1][j - 1] == 'O' &&
                  grille[i + 1][j + 1] == grille[i - 1][j - 1] &&
                  grille[i + 1][j + 1] == grille[i + 2][j + 2]
                ) ||
                (
                  grille[i - 1][j + 1] == 'O' &&
                  grille[i - 1][j - 1] == grille[i - 1][j + 1] &&
                  grille[i - 1][j - 1] == grille[i - 2][j - 2]
                ) ||
                (grille[i][j - 1] == 'O' && grille[i][j + 1] == grille[i][j - 1] && grille[i][j] == grille[i][j + 2]) ||
                (grille[i][j + 1] == 'O' && grille[i][j - 1] == grille[i][j + 1] && grille[i][j - 1] == grille[i][j - 2])
              ) {
                grille[i][j] = 'O';
                choix = 1;
                x = i;
                y = j;
              }
            }
          }
        }
      }
    }

    if (choix == 0) {
      for (i = 3; i <= 9; i++) {
        for (j = 3; j <= 10; j++) {
          if (choix == 0) {
            if (grille[i][j] == '*' && (grille[i + 1][j] == 'X' || grille[i + 1][j] == 'O' || grille[i + 1][j] == '$')) {
              if (
                (grille[i + 1][j] == 'X' && grille[i + 1][j] == grille[i + 2][j] && grille[i + 2][j] == grille[i + 3][j]) ||
                (
                  grille[i + 1][j - 1] == 'X' &&
                  grille[i + 1][j - 1] == grille[i + 2][j - 2] &&
                  grille[i + 2][j - 2] == grille[i + 3][j - 3]
                ) ||
                (grille[i][j - 1] == 'X' && grille[i][j - 1] == grille[i][j - 2] && grille[i][j - 2] == grille[i][j - 3]) ||
                (
                  grille[i - 1][j - 1] == 'X' &&
                  grille[i - 1][j - 1] == grille[i - 2][j - 2] &&
                  grille[i - 2][j - 2] == grille[i - 3][j - 3]
                ) ||
                (
                  grille[i - 1][j + 1] == 'X' &&
                  grille[i - 1][j + 1] == grille[i - 2][j + 2] &&
                  grille[i - 2][j + 2] == grille[i - 3][j + 3]
                ) ||
                (grille[i][j + 1] == 'X' && grille[i][j + 1] == grille[i][j + 2] && grille[i][j + 2] == grille[i][j + 3]) ||
                (
                  grille[i + 1][j + 1] == 'X' &&
                  grille[i + 1][j + 1] == grille[i + 2][j + 2] &&
                  grille[i + 2][j + 2] == grille[i + 3][j + 3]
                ) ||
                (
                  grille[i + 1][j + 1] == 'X' &&
                  grille[i - 1][j - 1] == grille[i + 1][j + 1] &&
                  grille[i - 1][j - 1] == grille[i - 2][j - 2]
                ) ||
                (
                  grille[i - 1][j - 1] == 'X' &&
                  grille[i + 1][j + 1] == grille[i - 1][j - 1] &&
                  grille[i + 1][j + 1] == grille[i + 2][j + 2]
                ) ||
                (
                  grille[i - 1][j - 1] == 'X' &&
                  grille[i + 1][j + 1] == grille[i - 1][j - 1] &&
                  grille[i + 1][j + 1] == grille[i + 2][j + 2]
                ) ||
                (
                  grille[i - 1][j + 1] == 'X' &&
                  grille[i - 1][j - 1] == grille[i - 1][j + 1] &&
                  grille[i - 1][j - 1] == grille[i - 2][j - 2]
                ) ||
                (grille[i][j - 1] == 'X' && grille[i][j + 1] == grille[i][j - 1] && grille[i][j] == grille[i][j + 2]) ||
                (grille[i][j + 1] == 'X' && grille[i][j - 1] == grille[i][j + 1] && grille[i][j - 1] == grille[i][j - 2])
              ) {
                grille[i][j] = 'O';
                choix = 1;
                x = i;
                y = j;
              }
            }
          }
        }
      }
    }

    if (choix == 0) {
      for (i = 3; i <= 9; i++) {
        for (j = 3; j <= 10; j++) {
          if (choix == 0) {
            if (grille[i][j] == '*' && (grille[i + 1][j] == 'X' || grille[i + 1][j] == 'O' || grille[i + 1][j] == '$')) {
              if (
                (grille[i + 1][j] == 'O' && grille[i + 1][j] == grille[i + 2][j]) ||
                (grille[i + 1][j - 1] == 'O' && grille[i + 1][j - 1] == grille[i + 2][j - 2]) ||
                (grille[i][j - 1] == 'O' && grille[i][j - 1] == grille[i][j - 2]) ||
                (grille[i - 1][j - 1] == 'O' && grille[i - 1][j - 1] == grille[i - 2][j - 2]) ||
                (grille[i - 1][j + 1] == 'O' && grille[i - 1][j + 1] == grille[i - 2][j + 2]) ||
                (grille[i][j + 1] == 'O' && grille[i][j + 1] == grille[i][j + 2]) ||
                (grille[i + 1][j + 1] == 'O' && grille[i + 1][j + 1] == grille[i + 2][j + 2]) ||
                (grille[i + 1][j + 1] == 'O' && grille[i - 1][j - 1] == grille[i + 1][j + 1]) ||
                (grille[i - 1][j - 1] == 'O' && grille[i + 1][j + 1] == grille[i - 1][j - 1]) ||
                (grille[i - 1][j - 1] == 'O' && grille[i + 1][j + 1] == grille[i - 1][j - 1]) ||
                (grille[i - 1][j + 1] == 'O' && grille[i - 1][j - 1] == grille[i - 1][j + 1]) ||
                (grille[i][j - 1] == 'O' && grille[i][j + 1] == grille[i][j - 1]) ||
                (grille[i][j + 1] == 'O' && grille[i][j - 1] == grille[i][j + 1])
              ) {
                grille[i][j] = 'O';
                choix = 1;
                x = i;
                y = j;
              }
            }
          }
        }
      }
    }

    if (choix == 0) {
      for (i = 3; i <= 9; i++) {
        for (j = 3; j <= 10; j++) {
          if (choix == 0) {
            if (grille[i][j] == '*' && (grille[i + 1][j] == 'X' || grille[i + 1][j] == 'O' || grille[i + 1][j] == '$')) {
              if (
                grille[i + 1][j] == 'O' ||
                grille[i + 1][j - 1] == 'O' ||
                grille[i][j - 1] == 'O' ||
                grille[i - 1][j - 1] == 'O' ||
                grille[i - 1][j + 1] == 'O' ||
                grille[i][j + 1] == 'O' ||
                grille[i + 1][j + 1] == 'O'
              ) {
                grille[i][j] = 'O';
                choix = 1;
                x = i;
                y = j;
              }
            }
          }
        }
      }
    }

    if (choix == 0) {
      x = 9;
      if (grille[x][7] == 'X') {
        y = 8;
        grille[x][y] = 'O';
      } else {
        y = 7;
        grille[x][y] = 'O';
      }
    }
    boolean gagne = estGagne(x, y);
    afficherGrille();
    return gagne;
  }

  public boolean estGagne(int i, int j) {
    if (
      (grille[i][j] == grille[i + 1][j] && grille[i + 1][j] == grille[i + 2][j] && grille[i + 2][j] == grille[i + 3][j]) ||
      (
        grille[i][j] == grille[i + 1][j - 1] && grille[i + 1][j - 1] == grille[i + 2][j - 2] && grille[i + 2][j - 2] == grille[i + 3][j - 3]
      ) ||
      (grille[i][j] == grille[i][j - 1] && grille[i][j - 1] == grille[i][j - 2] && grille[i][j - 2] == grille[i][j - 3]) ||
      (
        grille[i][j] == grille[i - 1][j - 1] && grille[i - 1][j - 1] == grille[i - 2][j - 2] && grille[i - 2][j - 2] == grille[i - 3][j - 3]
      ) ||
      (
        grille[i][j] == grille[i - 1][j + 1] && grille[i - 1][j + 1] == grille[i - 2][j + 2] && grille[i - 2][j + 2] == grille[i - 3][j + 3]
      ) ||
      (grille[i][j] == grille[i][j + 1] && grille[i][j + 1] == grille[i][j + 2] && grille[i][j + 2] == grille[i][j + 3]) ||
      (
        grille[i][j] == grille[i + 1][j + 1] && grille[i + 1][j + 1] == grille[i + 2][j + 2] && grille[i + 2][j + 2] == grille[i + 3][j + 3]
      ) ||
      (grille[i][j] == grille[i + 1][j + 1] && grille[i][j] == grille[i - 1][j - 1] && grille[i - 1][j - 1] == grille[i - 2][j - 2]) ||
      (grille[i][j] == grille[i - 1][j - 1] && grille[i][j] == grille[i + 1][j + 1] && grille[i + 1][j + 1] == grille[i + 2][j + 2]) ||
      (grille[i][j] == grille[i - 1][j - 1] && grille[i][j] == grille[i + 1][j + 1] && grille[i + 1][j + 1] == grille[i + 2][j + 2]) ||
      (grille[i][j] == grille[i - 1][j + 1] && grille[i][j] == grille[i - 1][j - 1] && grille[i - 1][j - 1] == grille[i - 2][j - 2]) ||
      (grille[i][j] == grille[i][j - 1] && grille[i][j] == grille[i][j + 1] && grille[i][j] == grille[i][j + 2]) ||
      (grille[i][j] == grille[i][j + 1] && grille[i][j] == grille[i][j - 1] && grille[i][j - 1] == grille[i][j - 2])
    ) return true;

    return false;
  }

  public static Integer afficherRegle() {
    int retour;
    Scanner sc = new Scanner(System.in);
    System.out.println(
      "\tLe but du jeu est d'aligner 4 pions sur une grille comptant 7 rangées et 8 colonnes. Chaque joueur dispose de 28 pions d'une certain forme (par convention X ou O). Tour à tour les deux joueurs placent un pion dans la colonne de leur choix. Le vainqueur est le joueur qui réalise le premier un alignement (horizontal, vertical ou diagonal) d'au moins quatre pions de sa meme forme. Si alors que toutes les cases de la grille de jeu sont remplies aucun des deux joueurs n'a réalisé un tel alignement, la partie est déclarée nulle.\n"
    );
    do {
      System.out.println("[1] Retour");
      retour = sc.nextInt();
    } while (retour > 1 || retour < 1);
    return retour;
  }

  public static void main(String[] args) {
    int choixMenu, exit;
    String prenom1;
    String prenom2;

    Scanner sc = new Scanner(System.in);

    choixMenu = menu();
    if (choixMenu == 3) {
      exit = afficherRegle();
      if (exit == 1) choixMenu = menu();
    }

    boolean gagner;
    if (choixMenu == 2) {
      Puissance4 game = new Puissance4();

      System.out.println("\tEntrez le prenom d'un des deux joueurs\n");
      prenom1 = sc.nextLine();
      System.out.println("\tEntrez le prenom d'un des deux joueurs\n");
      prenom2 = sc.nextLine();
      System.out.println("\t " + prenom1 + " vs  " + prenom2 + "\n");

      do {
        game.afficherGrille();
        gagner = game.jouer(JOUEUR_1);

        if (gagner) System.out.println(prenom1 + " a gagné !");

        if (!gagner) {
          gagner = game.jouer(JOUEUR_2);
          if (gagner) System.out.println(prenom2 + " a gagné !");
        }
      } while (!gagner);
    }

    if (choixMenu == 1) {
      Puissance4 game = new Puissance4();

      System.out.println("\tEntrez le prenom d'un des deux joueurs\n");
      prenom1 = sc.nextLine();
      System.out.println("\t " + prenom1 + " vs ordinateur");

      do {
        game.afficherGrille();
        gagner = game.jouer(JOUEUR_1);

        if (gagner) System.out.println(prenom1 + " a gagné !");

        if (!gagner) {
          gagner = game.jouerIA();
          if (gagner) System.out.println(" L'ordinateur a gagné !");
        }
      } while (!gagner);
    }
  }
}
