# Twitch live codings

Ce dépôt Git a pour but de partager les différents ateliers pouvant être réalisés durant les sessions live coding d'Ippon Technologies sur sa chaîne Twitch.

-   [Discord](https://discord.gg/CVEpfFnPcY)
-   [Calendrier des lives](https://calendar.google.com/calendar/embed?src=c_07pbpmtv1a4d0iu48tnm6tl328%40group.calendar.google.com&ctz=Europe%2FParis) _A ajouter à votre agenda en cliquant sur le + en bas_
-   [Chaîne Twitch](https://www.twitch.tv/ippontech)

# Applications

On code entierement quelques petites applications les lives, n'hésitez pas à nous piquer des idées !

-   [Borestop](/borestop): Utilisation de la pyramide de tests pour apporter rapidement de la valeure
-   [PadBowl](https://gitlab.com/cdamon/padbowl): "Utilisation" du DDD dans une application basée sur JHipster
-   [NERP](https://gitlab.com/cdamon/nerp): Utilisation des méthodologies présentées sur la chaine pour construire totalement une application (en cours)

# Kata

Un kata de code est un petit exercice pensé pour s'entrainer jusqu'à maitriser une compétence donnée.

## Java

### Facile

-   [RomanNumerals](/roman-numerals)
-   [Pagination Seven](/java-pagination-seven)
-   [Mustache Replacer](/mustache-replacer)
-   [Fizz Buzz](/fizz-buzz)
-   [Leap years](/leap-years)
-   [Employee report](/employee-report)
-   [Employee report 2](/employee-report-2)

### Moyen

-   [WordWrap](/word-wrap)
-   [StringCalculator](/string-calculator)
-   [UglyTrivia](/ugly-trivia)
-   [Trip service](/trip-service-kata)
-   [String calculator 2](/string-calculator-2)
-   [TCR - Roman Numerals](/tcr-roman-numerals)
-   [H2G2](/java-h2g2)
-   [Puissance 4](/puissance-4)
-   [CodingGame Mars Landing Party](https://www.youtube.com/watch?v=FeJa3UnmeHw)
-   [Movie rental](/movie-rental)
-   [Bowling Game](/bowling-game)
-   [Tennis Refactoring kata](/tennis/refactoring)
-   [Puzzles](java-puzzles)
-   [Diamond](java-diamond)
-   [Markov chain](markov-chain)
-   [Names](names)

### Énervé

-   [GildedRose](/gilded-rose)
-   [Game of life](/game-of-life)
-   [Gilded rose without flow control](/gilded-rose-without-flow-control)

## TypeScript

### Moyen

-   [Pagination Seven](/pagination-seven)
-   [A Brief History of Date](/a-brief-history-of-date)
-   [Trip service (TypeScript)](/trip-service-kata-typescript)
-   [Roman calculator](/roman-calculator)
-   [H2G2](/h2g2)
-   [Mastermind](/mastermind)
-   [Diamond](/diamond-ts)

## Front

### Moyen

-   [Atomic Design I and II](https://gitlab.ippon.fr/arey/pattern-library)

# Code & coffee

## Java

### Facile

-   [Factory patterns](/factory-patterns)
-   [Exceptions](/exceptions)

### Moyen

-   [Java streams](/java-streams)

### Énervé

-   [Concurrence en Java](/java-concurrence)
-   [Try monade](/try-monade)
-   [Memoizers](/java-memoizers)

### Bon Chance

-   [Monades en java](/java-monades)

# Discussions et présentations

-   [C'est une bonne situation ça techlead ?](https://www.youtube.com/watch?v=9tOoXfOE12o)
-   [GreenIT: simple coup de peinture ou réelle démarche écologique ?](https://www.youtube.com/watch?v=liTuZZTCpGc)
-   [Une annonce pour recruter un crafter - Caroline, Chloé, Ianic et Colin](https://www.youtube.com/watch?v=E5AX6Ar1Fog)
-   [Proxifier son localhost avec un nginx dockerisé avec Edouard CATTEZ](https://www.youtube.com/watch?v=qWMfRb3zK7k)
-   [Dev pour des data scientists, un sale boulot](https://www.youtube.com/watch?v=QK3OJGAresE)
-   [Back from GDCR avec Maxime, Séraphin, Anthony et Colin](https://www.youtube.com/watch?v=CHfUGdnSX6I)
-   [Résilience des data pipelines](https://youtu.be/xvpUHAWN_fg)
-   Tables rondes Prismea
    - [1 an de craft chez Prismea](https://youtu.be/8x9_hpL0jj0)
    - [Front](https://www.twitch.tv/videos/927836725)
    - [Back](https://www.twitch.tv/videos/945101371)
    - [Ops](https://www.twitch.tv/videos/953867094)
-   [Retour sur les 3 jours de conférences de DDD Europe](https://youtu.be/sDUuDpnLWXs)
-   [Du craft dans mon code : de la valeur sur ma prod !](https://youtu.be/JvrNRbZhtHo)
-   [Le craft au travers d'une jeune équipe de développement](https://youtu.be/ED0dyPHW3VU)
-   [On écrit un article de Blog sur le design d'API REST](https://www.twitch.tv/videos/880785124)
-   On écrit un article de Blog sur les environnements dans GitLab [Partie 1](https://www.twitch.tv/videos/887559700) [Partie 2](https://www.twitch.tv/videos/892375090)
-   [Présentation Ippon Scale Studio](https://www.twitch.tv/videos/953878040)
-   [Kata with test data builders and the Mikado method](https://www.twitch.tv/videos/950081628)
-   [Code & coffee - Les building blocks du DDD](https://www.twitch.tv/videos/1044277339)
-   [Rover kata en RUST](https://www.twitch.tv/videos/1056298346)
