package fr.ippon.kata.roman;

import java.util.NavigableMap;
import java.util.TreeMap;

public final class Numerals {

  private static final NavigableMap<Integer, Roman> CONVERSIONS = buildConversions();

  private Numerals() {}

  public static String toRoman(int arabic) {
    if (arabic <= 0) {
      return "";
    }

    Integer highestKnownConversion = CONVERSIONS.floorKey(arabic);

    String highestKnownRepresentation = CONVERSIONS.get(highestKnownConversion).getRepresentation();

    return (highestKnownRepresentation + toRoman(arabic - highestKnownConversion));
  }

  private static NavigableMap<Integer, Roman> buildConversions() {
    NavigableMap<Integer, Roman> conversions = new TreeMap<>();

    conversions.put(1, Roman.ONE);
    conversions.put(4, Roman.FOUR);
    conversions.put(5, Roman.FIVE);
    conversions.put(9, Roman.NINE);
    conversions.put(10, Roman.TEN);

    return conversions;
  }
}
