package fr.ippon.kata.roman;

import static fr.ippon.kata.roman.Numerals.toRoman;
import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Test;

class NumeralsTest {

  @Test
  void shouldConvertZeroToEmptyString() {
    assertThat(toRoman(0)).isEmpty();
  }

  @Test
  void shouldConvertOneToI() {
    assertThat(toRoman(1)).isEqualTo("I");
  }

  @Test
  void shouldConvertThreeToIII() {
    assertThat(toRoman(3)).isEqualTo("III");
  }

  @Test
  void shouldConvertFourToIV() {
    assertThat(toRoman(4)).isEqualTo("IV");
  }

  @Test
  void shouldConvertFiveToV() {
    assertThat(toRoman(5)).isEqualTo("V");
  }

  @Test
  void shouldConvertSixToVI() {
    assertThat(toRoman(6)).isEqualTo("VI");
  }

  @Test
  void shouldConvertNineToIX() {
    assertThat(toRoman(9)).isEqualTo("IX");
  }

  @Test
  void shouldConvertTenToX() {
    assertThat(toRoman(10)).isEqualTo("X");
  }

  @Test
  void shouldConvertFourteenToXIV() {
    assertThat(toRoman(14)).isEqualTo("XIV");
  }
}
