package fr.ippon.tennis;

public class Game {

  private static final String STARTING_DISPLAY = "LOVE - ALL";
  private static final String SEPARATOR = " - ";

  private Score playerOne = Score.LOVE;
  private Score playerTwo = Score.LOVE;

  public void playerOneScores() {
    if (playerOne == Score.FOURTY && playerTwo == Score.ENDING) {
      thisIsADeuce();
    } else {
      playerOne = playerOne.scores();
    }
  }

  public void playerTwoScores() {
    if (playerOne == Score.ENDING && playerTwo == Score.FOURTY) {
      thisIsADeuce();
    } else {
      playerTwo = playerTwo.scores();
    }
  }

  private void thisIsADeuce() {
    playerOne = Score.FOURTY;
    playerTwo = Score.FOURTY;
  }

  public String score() {
    if (playerHasScored()) {
      return displayScore();
    }

    return STARTING_DISPLAY;
  }

  private String displayScore() {
    if (playerOne == Score.ENDING && playerTwo == Score.FOURTY) {
      return "ADVANTAGE PLAYER 1";
    }

    if (playerTwo == Score.ENDING && playerOne == Score.FOURTY) {
      return "ADVANTAGE PLAYER 2";
    }

    if (playerOne == Score.ENDING) {
      return "GAME PLAYER 1";
    }

    if (playerTwo == Score.ENDING) {
      return "GAME PLAYER 2";
    }

    if (equality()) {
      return equalityDisplay();
    }

    return playerOne.display() + SEPARATOR + playerTwo.display();
  }

  private boolean equality() {
    return playerOne == playerTwo;
  }

  private String equalityDisplay() {
    if (playerOne == Score.FOURTY) {
      return "DEUCE";
    }

    return playerOne.display() + SEPARATOR + "ALL";
  }

  private boolean playerHasScored() {
    return playerOne.hasScored() || playerTwo.hasScored();
  }
}
